package com.example.demo;

import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.slf4j.MDC;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
public class ThrowingExceptionController {

    private static final Logger logger = LoggerFactory.getLogger(ThrowingExceptionController.class);


    @GetMapping("/index.html")
    @ResponseBody
    public Map<String, String> index() {
        if (true) {
            throw new RuntimeException("Throwing exception in ClassThrowingException");
        }
        return Map.of("message", "ok");
    }

    @ExceptionHandler(Exception.class)
    public ResponseEntity<Map<String, String>> handleException(Exception e) {
        MDC.put("error", "demo");
        logger.error("There has been an error: " + e.getMessage(), e);
        MDC.remove("demo");

        return ResponseEntity
                .internalServerError()
                .body(Map.of(
                        "message", "There has been an error: " + e.getMessage()
                ));
    }

}
